function GroundedMovement(groundMovementImpulseMagnitude, airMovementImpulseMagnitude,  groundSpeedLimit, airSpeedLimit, onGroundTime, idleFriction){
    this._groundMovementImpulseMagnitude = groundMovementImpulseMagnitude || 0;
    this._airMovementImpulseMagnitude = airMovementImpulseMagnitude || 0;
    this._groundSpeedLimit = groundSpeedLimit || 0;
    this._airSpeedLimit = airSpeedLimit || 0;
    this._onGroundTime = onGroundTime || 0;
    this._idleFriction = idleFriction || 0;
    
    this._onGroundTimeRemaining = 0;
    this._groundRightTangent = new Vector2D();
    this._movedInDesiredDirection = false;
}

GroundedMovement.prototype = {
    constructor : GroundedMovement,
    _componentIdentifier : 0,
    
    getGroundMovementImpulseMagnitude : function(){
        return this._groundMovementImpulseMagnitude;
    },
    
    setGroundMovementImpulseMagnitude : function(magnitude){
        this._groundMovementImpulseMagnitude = magnitude;
    },
    
    getAirMovementImpulseMagnitude : function(){
        return this._airMovementImpulseMagnitude;
    },
    
    setAirMovementImpulseMagnitude : function(magnitude){
        this._airMovementImpulseMagnitude = magnitude;
    },
    
    getGroundSpeedLimit : function(){
        return this._groundSpeedLimit;
    },
    
    setGroundSpeedLimit : function(groundSpeedLimit){
        this._groundSpeedLimit = groundSpeedLimit;
    },
    
    getAirSpeedLimit : function(){
        return this._airSpeedLimit;
    },
    
    setAirSpeedLimit : function(airSpeedLimit){
        this._airSpeedLimit = airSpeedLimit;
    },
    
    getOnGroundTime : function(){
        return this._onGroundTime;
    },
    
    setOnGroundTime : function(onGroundTime){
        this._onGroundTime = onGroundTime;
    },
    
    isOnGround : function(){
        return this._onGroundTimeRemaining > 0;
    },
    
    getIdleFriction : function(){
        return this._idleFriction;
    },
    
    setIdleFriction : function(friction){
        this._idleFriction = friction;
    }
};

function FacingDirection(facingDirection){
    this._facingDirection = facingDirection || 'right';
}

FacingDirection.prototype = {
    constructor : FacingDirection,
    _componentIdentifier : 0,
    
    getFacingDirection : function(){
        return this._facingDirection;
    },
    
    setFacingDirection : function(facingDirection){
        this._facingDirection = facingDirection;
    }
};